<?php

namespace oTools\http;

class type
{
	protected static $types = [
		'aab' => ['application/x-authorware-bin','binary'],
		'aam' => ['application/x-authorware-map','binary'],
		'aas' => ['application/x-authorware-seg','binary'],
		'aba' => ['audio/x-bamba','binary'],
		'ai' => ['application/postscript','vectoriel'],
		'aif' => ['audio/x-aiff','binary'],
		'aifc' => ['audio/x-aiff','binary'],
		'aiff' => ['audio/x-aiff','binary'],
		'asf' => ['video/x-ms-asf','binary'],
		'asx' => ['video/x-ms-asf','binary'],
		'au' => ['audio/basic','sound'],
		'avi' => ['video/x-msvideo','video'],
		'bcpio' => ['application/x-bcpio','binary'],
		'bmp' => ['image/bmp','image'],
		'bz2' => ['application/x-bzip2','tar'],
		'ccn' => ['application/x-cnc','binary'],
		'cco' => ['application/x-cocoa','binary'],
		'cdf' => ['application/x-netcdf','binary'],
		'cgi' => ['application/x-httpd-cgi','binary'],
		'cha' => ['audio/x-chacha','binary'],
		'cpio' => ['application/x-cpio','binary'],
		'cpt' => ['application/mac-compactpro','binary'],
		'cqk' => ['application/x-calquick','binary'],
		'csh' => ['application/x-csh','binary'],
		'csm' => ['chemical/x-csml','binary'],
		'css' => ['text/css','css'],
		'd96' => ['x-world/x-d96','binary'],
		'dcr' => ['application/x-director','binary'],
		'dir' => ['application/x-director','binary'],
		'dll' => ['application/octet-stream','windows'],
		'dvi' => ['application/x-dvi','binary'],
		'dxr' => ['application/x-director','binary'],
		'ebk' => ['application/x-expandedbook','binary'],
		'emb' => ['chemical/x-embl-dl-nucleotide','binary'],
		'eps' => ['application/postscript','ps'],
		'es' => ['audio/echospeech','binary'],
		'etx' => ['text/x-setext','binary'],
		'exe' => ['application/octet-stream','windows'],
		'fh' => ['image/x-freehand','binary'],
		'fh4' => ['image/x-freehand','binary'],
		'fh5' => ['image/x-freehand','binary'],
		'fh7' => ['image/x-freehand','binary'],
		'fhc' => ['image/x-freehand','binary'],
		'fif' => ['image/fif','binary'],
		'gau' => ['chemical/x-gaussian-input','binary'],
		'gif' => ['image/gif','image'],
		'gpx' => ['application/gpx+xml','binary'],
		'gtar' => ['application/x-gtar','tar'],
		'gz' => ['application/x-gzip','tar'],
		'hdf' => ['application/x-hdf','binary'],
		'hqx' => ['application/mac-binhex40','binary'],
		'htm' => ['text/html','html'],
		'html' => ['text/html','html'],
		'ice' => ['x-conference/x-cooltalk','binary'],
		'ief' => ['image/ief','binary'],
		'ivr' => ['i-world/i-vrml','binary'],
		'jpe' => ['image/jpeg','image'],
		'jpeg' => ['image/jpeg','image'],
		'jpg' => ['image/jpeg','image'],
		'jps' => ['image/x-jps','binary'],
		'js' => ['application/x-javascript','js'],
		'kar' => ['audio/midi','binary'],
		'latex' => ['application/x-latex','binary'],
		'lcc' => ['application/fastman','binary'],
		'lha' => ['application/x-lzh','tar'],
		'ls' => ['application/x-javascript','binary'],
		'lzh' => ['application/x-lzh','binary'],
		'man' => ['application/x-troff-man','binary'],
		'mcf' => ['image/vasa','binary'],
		'mct' => ['application/x-mascot','binary'],
		'me' => ['application/x-troff-me','binary'],
		'mid' => ['audio/midi','midi'],
		'midi' => ['audio/midi','midi'],
		'mif' => ['application/x-mif','binary'],
		'mio' => ['audio/x-mio','binary'],
		'mocha' => ['application/x-javascript','binary'],
		'mol' => ['chemical/x-mdl-molfile','binary'],
		'mop' => ['chemical/x-mopac-input','binary'],
		'mov' => ['video/quicktime','video'],
		'movie' => ['video/x-sgi-movie','binary'],
		'mp2' => ['audio/mpeg','binary'],
		'mp3' => ['audio/mpeg','sound'],
		'mp4' => ['video/mp4','video'],
		'mpe' => ['video/mpeg','binary'],
		'mpeg' => ['video/mpeg','video'],
		'mpg' => ['video/mpeg','video'],
		'mpga' => ['audio/mpeg','binary'],
		'mpp' => ['application/x-pixelscooter','binary'],
		'mps' => ['application/x-mapserver','binary'],
		'ms' => ['application/x-troff-ms','binary'],
		'msi' => ['application/octet-stream','windows'],
		'mus' => ['x-world/x-d96','binary'],
		'nc' => ['application/x-netcdf','binary'],
		'nml' => ['animation/narrative','binary'],
		'oda' => ['application/oda','binary'],
		'pac' => ['application/x-ns-proxy-auto-config','binary'],
		'pan' => ['world/x-panoramix','binary'],
		'pbm' => ['image/x-portable-bitmap','binary'],
		'pdb' => ['chemical/x-pdb','binary'],
		'pdf' => ['application/pdf','pdf'],
		'pfr' => ['application/font-tdpfr','binary'],
		'pgm' => ['image/x-portable-graymap','binary'],
		'php' => ['text/plain','php'],
		'png' => ['image/png','image'],
		'pnm' => ['image/x-portable-anymap','binary'],
		'pot' => ['application/mspowerpoint','binary'],
		'ppm' => ['image/x-portable-pixmap','binary'],
		'pps' => ['application/mspowerpoint','binary'],
		'ppt' => ['application/mspowerpoint','binary'],
		'ppz' => ['application/mspowerpoint','binary'],
		'ps' => ['application/postscript','ps'],
		'ptlk' => ['plugin/listenup','binary'],
		'qm' => ['video/x-qmsys','binary'],
		'qt' => ['video/quicktime','binary'],
		'ra' => ['audio/vnd.rn-realaudio','binary'],
		'ram' => ['audio/x-pn-realaudio','binary'],
		'ras' => ['image/x-cmu-raster','binary'],
		'rgb' => ['image/x-rgb','binary'],
		'rm' => ['audio/x-pn-realaudio','binary'],
		'roff' => ['application/x-troff','binary'],
		'rp' => ['image/vnd.rn-realpix','binary'],
		'rpm' => ['audio/x-pn-realaudio-plugin','binary'],
		'rss' => ['application/rss+xml','rss',true],
		'rt' => ['text/vnd.rn-realtext','binary'],
		'rtf' => ['application/rtf','binary'],
		'rtx' => ['text/richtext','binary'],
		'rv' => ['video/vnd.rn-realvideo','binary'],
		'sgm' => ['text/x-sgml','binary'],
		'sgml' => ['text/x-sgml','binary'],
		'sh' => ['application/x-sh','binary'],
		'shar' => ['application/x-shar','binary'],
		'sit' => ['application/x-stuffit','binary'],
		'skd' => ['application/x-koan','binary'],
		'skm' => ['application/x-koan','binary'],
		'skp' => ['application/x-koan','binary'],
		'skt' => ['application/x-koan','binary'],
		'smi' => ['application/smil','binary'],
		'snd' => ['audio/basic','binary'],
		'spl' => ['application/futuresplash','binary'],
		'spr' => ['application/x-sprite','binary'],
		'sprite' => ['application/x-sprite','binary'],
		'spt' => ['application/x-spt','binary'],
		'src' => ['application/x-wais-source','binary'],
		'sv4cpio' => ['application/x-sv4cpio','binary'],
		'sv4crc' => ['application/x-sv4crc','binary'],
		'svi' => ['application/softvision','binary'],
		'svr' => ['x-world/x-svr','binary'],
		'swf' => ['application/x-shockwave-flash','binary'],
		'swx' => ['image/x-xres','binary'],
		't' => ['application/x-troff','binary'],
		'talk' => ['text/x-speech','binary'],
		'tar' => ['application/x-tar','binary'],
		'tcl' => ['application/x-tcl','binary'],
		'tex' => ['application/x-tex','binary'],
		'texi' => ['application/x-texinfo','binary'],
		'texinfo' => ['application/x-texinfo','binary'],
		'tgo' => ['video/x-tango','binary'],
		'tgz' => ['application/x-tar','tar'],
		'tif' => ['image/tiff','binary'],
		'tiff' => ['image/tiff','binary'],
		'tr' => ['application/x-troff','binary'],
		'tsi' => ['audio/tsplayer','binary'],
		'tsp' => ['application/dsptype','binary'],
		'tsv' => ['text/tab-separated-values','binary'],
		'ttz' => ['application/t-time','binary'],
		'txt' => ['text/plain','txt'],
		'ustar' => ['application/x-ustar','binary'],
		'vba' => ['video/x-bamba','binary'],
		'vcd' => ['application/x-cdlink','binary'],
		'vcf' => ['text/x-vcard','binary'],
		'vif' => ['video/x-vif','binary'],
		'viv' => ['video/vnd.vivo','binary'],
		'vivo' => ['video/vnd.vivo','binary'],
		'vox' => ['audio/voxware','binary'],
		'vqe' => ['audio/x-twinvq-plugin','binary'],
		'vqf' => ['audio/x-twinvq','binary'],
		'vql' => ['audio/x-twinvq','binary'],
		'vrml' => ['x-world/x-vrml','binary'],
		'vts' => ['workbook/formulaone','binary'],
		'waf' => ['plugin/wanimate','binary'],
		'wan' => ['plugin/wanimate','binary'],
		'wav' => ['audio/x-wav','binary'],
		'wiki' => ['text/plain','wiki'],
		'wrl' => ['x-world/x-vrml','binary'],
		'xbm' => ['image/x-xbitmap','binary'],
		'xdm' => ['application/x-xdma','binary'],
		'xdma' => ['application/x-xdma','binary'],
		'xls' => ['application/x-excel','binary'],
		'xml' => ['text/xml','binary'],
		'xpm' => ['image/x-xpixmap','binary'],
		'xsl' => ['text/xsl','binary'],
		'xul' => ['application/vnd.mozilla.xul+xml','xul'],
		'xwd' => ['image/x-xwindowdump','binary'],
		'xyz' => ['chemical/x-xyz','binary'],
		'z' => ['application/x-compress','binary'],
		'zip' => ['application/zip','tar']
	];

	public static function mime($path)
	{
		$extension = fs::extension($path);
		if (array_key_exists($extension,self::$types))
			return self::$types[$extension][0];
		else
			return 'application/octet-stream';
	}
}
